---
title: Using the aria-labelledby attribute
slug: Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-labelledby_attribute
tags:
  - ARIA
  - Accessibility
  - broken link
---
<h3 id="Description">Description</h3>

<p><span class="seoSummary">The <a class="external" href="https://www.w3.org/TR/wai-aria/#aria-labelledby" rel="external" title="http://www.w3.org/TR/wai-aria/states_and_properties#aria-labelledby"><code>aria-labelledby</code></a> attribute establishes relationships between objects and their label(s), and its value should be one or more element IDs, which refer to elements that have the text needed for labeling. List multiple element IDs in a space delimited fashion.</span></p>

<div class="notecard note">
<p><span class="seoSummary">This idea is similar to how the "for" attribute is used to link a LABEL to an INPUT.</span></p>
</div>

<p><span class="seoSummary">Assistive technology, such as screen readers, use this attribute to catalog the objects in a document so that users can navigate between them. Without an element ID, the assistive technology cannot catalog the object.</span></p>

<p><code>aria-labelledby</code> is very similar to <a href="/en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-describedby_attribute" title="en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-describedby_attribute">aria-describedby</a>: A label provides essential information about an object, while a description provides extended information that the user might need.</p>

<p>In addition to form elements, you can use the <code>aria-labelledby</code> attribute to associate static text with widgets, groups of elements, panes, regions that have a heading, definitions, and other types of objects. The {{ anch("Examples") }} section below provides more information on how to use the attribute this way.</p>

<p>To improve compatibility with user agents that do not support ARIA, you can use <code>aria-labelledby</code> with the {{ HTMLElement("label") }} element (using the <code>for</code> attribute).</p>

<p>This attribute can be used with any typical HTML form element; it is not limited to elements that have an ARIA <code>role</code> assigned.</p>

<h3 id="Value">Value</h3>

<p>A space-separated list of element IDs</p>

<h3 id="Possible_effects_on_user_agents_and_assistive_technology">Possible effects on user agents and assistive technology </h3>

<p>When user agents compute the accessible name property of elements that have both an <code>aria-labelledby</code> attribute and an <a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-label_attribute" title="Using the aria-labelledby attribute"><code>aria-label</code></a> attribute, the user agents give precedence to <code>aria-labelledby</code>.</p>

<h3 id="Examples">Examples</h3>

<h4 id="Example_1_Multiple_Labels">Example 1: Multiple Labels</h4>

<p>In the example below, each input field is labelled by both its own individual label and by the label for the group:</p>

<pre class="brush: html">&lt;div id="myBillingId"&gt;Billing&lt;/div&gt;

&lt;div&gt;
    &lt;div id="myNameId"&gt;Name&lt;/div&gt;
    &lt;input type="text" aria-labelledby="myBillingId myNameId"/&gt;
&lt;/div&gt;
&lt;div&gt;
    &lt;div id="myAddressId"&gt;Address&lt;/div&gt;
    &lt;input type="text" aria-labelledby="myBillingId myAddressId"/&gt;
&lt;/div&gt;
</pre>

<h4 id="Example_2_Associating_Headings_With_Regions">Example 2: Associating Headings With Regions</h4>

<p>In the example below, header elements are associated with the content they head. Note that the region being referenced is the region that <em>contains</em> the header.</p>

<pre class="brush: html">&lt;div role="main" aria-labelledby="foo"&gt;
   &lt;h1 id="foo"&gt;Wild fires spread across the San Diego Hills&lt;/h1&gt;
   Strong winds expand fires ignited by high temperatures ...
&lt;/div&gt;
</pre>

<h4 id="Example_3_Radio_Groups">Example 3: Radio Groups</h4>

<p>In the example below, the container of a <a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_radio_role" title="Using the radio role">radiogroup</a> is associated with its label using the <code>aria-labelledby</code> attribute:</p>

<pre class="brush: html">&lt;div id="radio_label"&gt;My radio label&lt;/div&gt;
&lt;ul role="radiogroup" aria-labelledby="radio_label"&gt;
    &lt;li role="radio"&gt;Item #1&lt;/li&gt;
    &lt;li role="radio"&gt;Item #2&lt;/li&gt;
    &lt;li role="radio"&gt;Item #3&lt;/li&gt;
&lt;/ul&gt;
</pre>

<h4 id="Example_4_Dialog_Label">Example 4: Dialog Label</h4>

<p>In the example below, the header element that labels the dialog is referred to by the <code>aria-labelledby</code> attribute:</p>

<pre class="brush: html">&lt;div role="dialog" aria-labelledby="dialogheader"&gt;
    &lt;h2 id="dialogheader"&gt;Choose a File&lt;/h2&gt;
    ... Dialog contents
&lt;/div&gt;
</pre>

<h4 id="Example_5_Inline_Definition">Example 5: Inline Definition</h4>

<p>In the example below, the definition of a term that is described in the natural flow of the narrative is associated with the term itself using the <strong>aria-labelledby</strong> attribute:</p>

<pre class="brush: html">&lt;p&gt;The doctor explained it had been a &lt;dfn id="placebo"&gt;placebo&lt;/dfn&gt;, or &lt;span role="definition" aria-labelledby="placebo"&gt;
an inert preparation prescribed more for the mental relief of the patient than for its actual effect on a disorder.&lt;/span&gt;
&lt;/p&gt;
</pre>

<h4 id="Example_6_Definition_Lists">Example 6: Definition Lists</h4>

<p>In the example below, the definitions in a formal definition list are associated with the terms they define using the <code>aria-labelledby</code> attribute:</p>

<pre class="brush: html">&lt;dl&gt;
    &lt;dt id="anathema"&gt;anathema&lt;/dt&gt;
    &lt;dd role="definition" aria-labelledby="anathema"&gt;a ban or curse solemnly pronounced by ecclesiastical authority
                                                     and accompanied by excommunication&lt;/dd&gt;
    &lt;dd role="definition" aria-labelledby="anathema"&gt;a vigorous denunciation : cursor&lt;/dd&gt;

    &lt;dt id="homily"&gt;homily&lt;/dt&gt;
    &lt;dd role="definition" aria-labelledby="homily"&gt;a usually short sermon&lt;/dd&gt;
    &lt;dd role="definition" aria-labelledby="homily"&gt;a lecture or discourse on or of a moral theme&lt;/dd&gt;
&lt;/dl&gt;
</pre>

<h4 id="Example_7_Menus">Example 7: Menus</h4>

<p>In the example below, a popup menu is associated with its label using the <code>aria-labelledby</code> attribute:</p>

<pre class="brush: html">&lt;div role="menubar"&gt;
    &lt;div role="menuitem" aria-haspopup="true" id="fileMenu"&gt;File&lt;/div&gt;
    &lt;div role="menu" aria-labelledby="fileMenu"&gt;
        &lt;div role="menuitem"&gt;Open&lt;/div&gt;
        &lt;div role="menuitem"&gt;Save&lt;/div&gt;
        &lt;div role="menuitem"&gt;Save as ...&lt;/div&gt;
        ...
    &lt;/div&gt;
    ...
&lt;/div&gt;
</pre>

<h4 id="Notes">Notes </h4>

<p>The most common <em>accessibility API</em> mapping for a label is the <em>accessible name</em> property</p>

<h3 id="Used_by_ARIA_roles">Used by ARIA roles</h3>

<p>All elements of the base markup</p>

<h3 id="Related_ARIA_techniques">Related ARIA techniques </h3>

<ul>
 <li><a href="/en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-label_attribute" title="en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-label_attribute">Using the aria-label attribute</a></li>
 <li><a href="/en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-describedby_attribute" title="en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-describedby_attribute">Using the aria-describedby attribute</a></li>
</ul>

<h3 id="Compatibility">Compatibility</h3>

<p class="comment">TBD: Add support information for common UA and AT product combinations</p>

<h3 id="Additional_resources">Additional resources</h3>

<ul>
 <li><a class="external" href="https://www.w3.org/TR/wai-aria/#aria-labelledby" title="http://www.w3.org/TR/wai-aria/states_and_properties#aria-labelledby">WAI-ARIA specification for aria-labelledby</a></li>
</ul>
